<template>
  <div class="absolute inset-x-0 top-20">
    <form class="p-10 w-full justify-center" action="#" @submit.prevent="submit">
      <div class="flex flex-wrap -mx-3 mb-6">
        <div class="w-full md:w-1/2 px-3 mb-6 md:mb-0">
          <label
            class="block uppercase tracking-wide text-gray-700 text-xs font-bold mb-2"
            for="grid-first-name"
          >
            Date début de lecture
          </label>
          <input
            class="appearance-none block w-full bg-gray-200 text-gray-700 border rounded py-3 px-4 mb-3 leading-tight focus:outline-none focus:bg-white"
            id="grid-first-name"
            type="date"
            v-model="form.startDate"
          />
        </div>
        <div class="w-full md:w-1/2 px-3">
          <label
            class="block uppercase tracking-wide text-gray-700 text-xs font-bold mb-2"
            for="grid-last-name"
          >
            Date fin de lecture
          </label>
          <input
            class="appearance-none block w-full bg-gray-200 text-gray-700 border border-gray-200 rounded py-3 px-4 leading-tight focus:outline-none focus:bg-white focus:border-gray-500"
            v-model="form.endDate"
            id="grid-last-name"
            type="date"
          />
        </div>
      </div>
      <div class="flex flex-wrap -mx-3 mb-6">
        <div class="w-full px-3">
          <label
            class="block uppercase tracking-wide text-gray-700 text-xs font-bold mb-2"
            for="grid-password"
          >
            Avis
          </label>
          <input
            class="appearance-none block w-full bg-gray-200 text-gray-700 border border-gray-200 rounded py-3 px-4 mb-3 leading-tight focus:outline-none focus:bg-white focus:border-gray-500"
            id="grid-password"
            type="textarea"
            placeholder="Mon avis"
            v-model="form.avis"
          />
        </div>
      </div>
      <div class="flex flex-wrap -mx-3 mb-2">
        <div class="w-full md:w-1/3 px-3 mb-6 md:mb-0">
          <label
            class="block uppercase tracking-wide text-gray-700 text-xs font-bold mb-2"
            for="grid-state"
          >
            Note
          </label>
          <div class="relative">
            <select
              class="block appearance-none w-full bg-gray-200 border border-gray-200 text-gray-700 py-3 px-4 pr-8 rounded leading-tight focus:outline-none focus:bg-white focus:border-gray-500"
              id="grid-state"
              v-model="form.note"
            >
              <option>0</option>
              <option>1</option>
              <option>2</option>
              <option>3</option>
              <option>4</option>
              <option>5</option>
            </select>
            <div
              class="pointer-events-none absolute inset-y-0 right-0 flex items-center px-2 text-gray-700"
            >
              <svg
                class="fill-current h-4 w-4"
                xmlns="http://www.w3.org/2000/svg"
                viewBox="0 0 20 20"
              >
                <path
                  d="M9.293 12.95l.707.707L15.657 8l-1.414-1.414L10 10.828 5.757 6.586 4.343 8z"
                />
              </svg>
            </div>
          </div>
        </div>
      </div>

      <div class="flex items-center justify-center">
        <button
          type="submit"
          class="bg-orange-book hover:bg-orange-book-hover text-white font-bold py-2 px-4 rounded"
        >
          Noter
        </button>
      </div>
    </form>
  </div>
</template>

<script>
import {
  isKnowBook,
  addUserBook,
  updataData,
  isStatUser,
  createUserStat,
  updateStatUser,
  getUserBookByIdUserAndIdBook,
} from "./../services/firestoreService";
import { getCurrentUser } from "../services/authenticationService";
export default {
  name: "NotePage",

  data() {
    return {
      user: null,
      isbnBook: Number,
      form: {
        startDate: "",
        endDate: "",
        avis: "",
        note: 0,
      },
    };
  },

  async created() {
    this.isbnBook = this.$route.params.id;

    this.user = await getCurrentUser();
  },

  methods: {
    async submit() {
      this.createStatUser();

      if (await isKnowBook(this.user.uid, this.isbnBook)) {
        const relation = await getUserBookByIdUserAndIdBook(
          this.user.uid,
          this.isbnBook,
          "userBook"
        );
        await updataData(relation, "userBook", "note", this.form);
      } else {
        await addUserBook(this.user.uid, this.isbnBook, false, false, true, this.form);
      }
      await updateStatUser(this.user.uid, "note");

      this.$router.go(-1);
    },

    async createStatUser() {
      if (!(await isStatUser(this.user.uid))) {
        createUserStat(this.user.uid);
      }
    },
  },
};
</script>

<style></style>
